#include <stdio.h>
#include <stdlib.h> // srand(), rand()
#include <time.h>   // time()
//#define N 10

// prototypes
int size(int, char[21]);
void insert(int, int[]);
void sort(int, int[]);
void output(int, int[], const char);

int main(void){
	int MAX = 100;
	int N = size(MAX ,"arraysize");
	
	int arr[N];
	insert(N, arr);
	output(N, arr, 'o'); // original array
	sort(N, arr);
	output(N, arr, 'a'); // increasing
	output(N, arr, 'd'); // decreasing
	return 0;
}

int size(int MAX, char text[21]){
	int NN;
	do {
		printf("%s\n", text);
		scanf("%d", &NN);
	}
	while( NN<2 || NN>MAX );
	return NN;
}

void insert(int N, int arr[]){
	srand(time(NULL)); 
	                    
	int i;
	for(i=0;i<N;i++){
		arr[i] = (rand() % 100)-50;  	                        
	}
}

void sort(int N, int arr[]){
	int i, j, sorted = 0;
	for(i=0;i<N-1 && !sorted;i++){
		sorted = 1;
		for(j=0;j<N-i-1;j++){
			if(arr[j] < arr[j+1]){             
				arr[j] += arr[j+1];           
				arr[j+1] = arr[j] - arr[j+1];  
				arr[j] -= arr[j+1];            
				sorted = 0;
			}
		}
		if(sorted)
			printf("Row already sorted, exit function\n");
	}
}

void output(int N, int arr[], const char c){
	int i, j, k;
	switch(c){
		case 'o':
			printf("original array            : ");
			i = 0; j = N; k = 1;
			break;
		case 'a':
			printf(" Sorted ascending: ");
			i = N - 1; j = -1; k = -1;
			break;
		case 'd':
			printf("Sorted descending: ");
			i = 0; j = N; k = 1;
			break;
	}
	for(;i!=j;i+=k){ // for(i=0;i<N;i++) || for(i=N;i>0;i++)
		printf("%d ", arr[i]);
	}
	printf("\n");
}
